/*> bp.h
 * Support header for bp.c
 *
 * $Revision: 0.1 $
 *   $Author: jsmith $
 *     $Date: 941030 $
 *
 * Copyright (c) 1994, VLSI Technology Inc. All Rights Reserved.
 *
 * "@(#)bp.h	1.2	96/06/07 VLSI"
 */
/*---------------------------------------------------------------------------*/

#ifndef __cdemon_bp_h
#define __cdemon_bp_h

/*---------------------------------------------------------------------------*/

#if defined(RUBY2) && defined(HWBREAKPOINT)
#define     NumBP   1               /* only a single hardware breakpoint */
#else
#define     NumBP   16              /* number of break points supported */
#endif /* RUBY2 and HWBREAKPOINT */

#define     NORMAL  (NumBP + 1)     /* separate breakpoint from normal termination */

extern int BP_type ;

extern unsigned int BP_r0 ;
extern unsigned int BP_pc ;
extern unsigned int BP_CPSR ;
extern unsigned int BP_FIQ_r8 ;
extern unsigned int BP_FIQ_SPSR ;
extern unsigned int BP_IRQ_sp ;
extern unsigned int BP_IRQ_lr ;
extern unsigned int BP_IRQ_SPSR ;
extern unsigned int BP_SVC_sp ;
extern unsigned int BP_SVC_lr ;
extern unsigned int BP_SVC_SPSR ;
extern unsigned int BP_ABT_sp ;
extern unsigned int BP_ABT_lr ;
extern unsigned int BP_ABT_SPSR ;
extern unsigned int BP_UND_sp ;
extern unsigned int BP_UND_lr ;
extern unsigned int BP_UND_SPSR ;

/*---------------------------------------------------------------------------*/
/*
 * P r o t o t y p e s
 */
extern void BP_init(void) ;
extern void BP_Set(int ofs,int adr) ;
extern void BP_Clear(int ofs) ;
extern int  BP_Exist(int adr) ;
extern int  BP_Offset(int adr) ;

extern void RDI_Go(void) ;
extern void RDI_SingleStep(void) ; /* if hardware single-stepping supported */

/*---------------------------------------------------------------------------*/

#endif /* __cdemon_bp_h */

/*---------------------------------------------------------------------------*/
/*> EOF bp.h <*/
