	TTL	C-Demon SMC9192 ethernet header
	;
	; Copyright (c) 1995, VLSI Technology Inc. All Rights Reserved
	;
	; "@(#)e9192_h.s	1.2	96/06/07 VLSI"

; *I R Q   S t a t u s   a n d   E n a b l e   B i t s  (IRQS and IRQM)
SerialPortIT	EQU	0x1	; IRQ0;
TimerIT		EQU	0x2	; IRQ1;
IRQ2IT		EQU	0x4	; IRQ2;
EtherIT		EQU	0x8	; IRQ3 - Ethernet
IRQ4IT		EQU	0x10	; IRQ4;
IRQ5IT		EQU	0x20	; IRQ5;
IRQ6IT		EQU	0x40	; IRQ6;
IRQ7IT		EQU	0x80	; IRQ7 - Panic;
;       The SMC 92C9x Register Definitions

BankSel     EQU     0x1c            ; The Bank Select Register (Read/Write)
Bank0       EQU     0x00            ; To Select Bank 0
Bank1       EQU     0x01            ; To Select Bank 1
Bank2       EQU     0x02            ; To Select Bank 2
Bank3       EQU     0x03            ; To Select Bank 3

;       Register Bank #0 Definitions

TCR         EQU     0x00            ; Transmit Control Register (Read/Write)
EPHSR       EQU     0x04            ; EPH Status Register (Read Only)
RCR         EQU     0x08            ; Receive Control Register (Read/Write)
ECR         EQU     0x0c            ; Counter Register (Read Only)
MIR         EQU     0x10            ; Memory Information Register (Read Only)
EMCR        EQU     0x14            ; Memory Configuration Register (Read/Write)

;       Register Bank #1 Definitions

CR          EQU     0x00	; Configuration Register (Read/Write)
BAR         EQU     0x04 	; Base Address Register (Read/Write)
IAR1        EQU     0x08 	; Hi Individual Address Register #1 (R/W)
IAR2        EQU     0x08 	; Lo Individual Address Register #2 (R/W)
IAR3        EQU     0x0c 	; Hi Individual Address Register #3 (R/W)
IAR4        EQU     0x0c 	; Lo Individual Address Register #4 (R/W)
IAR5        EQU     0x10	; Hi Individual Address Register #5 (R/W)
IAR6        EQU     0x10	; Lo Individual Address Register #6 (R/W)
GPR         EQU     0x14 	; General Purpose Register (Read/Write)
CTR         EQU     0x18 	; Control Register (Read/Write)

;       Register Bank #2 Definitions
;       NOTE: The Interrupt Mask Register occupies the upper byte of the
;       halfword read from or written to the IST or ACK Registers

MMUCR       EQU     0x00            ; MMU Command Register (Read/Write)
PNR         EQU     0x04            ; Lo Packet Number Register (Read/Write)
ARR         EQU     0x04            ; Hi Allocation Result Register (Read Only)
FIFO        EQU     0x08            ; FIFO Ports Register (Read Only)
PTR         EQU     0x0c            ; Pointer Register (Read/Write)
DATAR       EQU     0x10            ; Data Register (Read/Write)
IST         EQU     0x18            ; Interrupt Status Register (Read Only)
ACK         EQU     0x18            ; Interrupt Acknowledge Register (Write)
;       Register Bank #3 Definitions

MT0         EQU     0x00            ; Lo MultiCast Table #0 Register (R/W)
MT1         EQU     0x00            ; Hi MultiCast Table #1 Register (R/W)
MT2         EQU     0x04            ; Lo MultiCast Table #2 Register (R/W)
MT3         EQU     0x04            ; Hi MultiCast Table #3 Register (R/W)
MT4         EQU     0x08            ; Lo MultiCast Table #4 Register (R/W)
MT5         EQU     0x08            ; Hi MultiCast Table #5 Register (R/W)
MT6         EQU     0x0c            ; Lo MultiCast Table #6 Register (R/W)
MT7         EQU     0x0c            ; Hi MultiCast Table #7 Register (R/W)

;       Bit Masks for the Transmit Control Register (Bank #0/TCR)

PAD_EN      EQU     0x0080          ; Enable padding to 64 bytes
TXENA       EQU     0x0001          ; Transmit Enable

;       Bit Masks for the Receive Control Register (Bank #0/RCR)

EPH_RST     EQU     0x8000          ; Software Reset
STRIP_CRC   EQU     0x0200          ; Strip Incoming CRCs   
RXEN        EQU     0x0100          ; Enables the Receiver
PRMS        EQU     0x0002          ; Promisuous mode
ALMUL       EQU     0x0004          ; Enables Multicast Receive 

;       Bit Masks for the Configuration Register (Bank #1/CR)

NO_WAIT_ST  EQU     0x1000          ; High = No Additional Wait States
AUI_SELECT  EQU     0x0100          ; High = AUI/Coax, Low = 10BaseT
Bit_16      EQU     0x0080          ; High = 16 Bit System Bus
DIS_LINK    EQU     0x0040          ; High = Disable Link Test
RAM_SIZE    EQU     0x0020          ; High = 32Kx8, Low = 8Kx8
AL_ONE      EQU     0x0010          ; Always a one

;       Bits for the Control Register (Bank #1/CTR)

AUTO_RELE   EQU     0x0800          ; auto release tx memory
TE_ENABLE   EQU     0x0020          ; High = Enable Transmit Error Interrupt
ESEL        EQU     0x0004          ; Selects EEProm for Read/Write
LOAD        EQU     0x0002          ; High = Read EEProm
STORE       EQU     0x0001          ; High = Write EEProm

;       Bits for the MMU Control Register (Bank #2/MMUCR)

MMU_BUSY    EQU     0x0001          ; MMU Busy
MMU_ALLOC   EQU     0x0020          ; Allocate  TX Memory
MMU_RESET   EQU     0x0040          ; MMU Reset Command
MMU_REMV    EQU     0x0060          ; Remove Frame from Top of RX FIFO
MMU_RMVRLS  EQU     0x0080          ; Remove & Release Frame
MMU_RLSFRM  EQU     0x00A0          ; Release Specific Frame
MMU_ENQUE   EQU     0x00C0          ; Enqueue a Frmae to TX FIFO
MMU_TXRESET EQU     0x00E0          ; Reset both TX FIFOs


;       Bits for the Interrupt and Mask Register (Bank #2/MSK)

RCV_INT		EQU	0x01	; Receive Interrupt
TX_INT		EQU	0x02	; Transmit Interrupt
TX_EMPTY	EQU	0x04	; Transmit Empty Interrupt
ALOC_INT	EQU	0x08	; Allocation Interrupt
RCV_OVR		EQU	0x10	; Receive Overrun Interrupt
EPH_INT		EQU	0x20	; EPH Interrupt

RCV_INTM     EQU     0x0100	; Receive Interrupt Mask
TX_INTM      EQU     0x0200	; Transmit Interrupt Mask
TX_EMPTYM    EQU     0x0400	; Transmit Empty Interrupt Mask
ALOC_INTM    EQU     0x0800	; Allocation Interrupt Mask
RCV_OVRM     EQU     0x1000	; Receive Overrun Interrupt Mask
EPH_INTM     EQU     0x2000 	; EPH Interrupt Mask


;       Bits for the Receive Frame Status Word

ALGN_ERR    EQU     0x8000          ; Frame had Alignment Error
BROD_CAST   EQU     0x4000          ; Frame was Broadcast
BAD_CRC     EQU     0x2000          ; Frame had Bad CRC
ODD_FRM     EQU     0x1000          ; Rec'd Frame had Odd Number of Bytes
TOO_LNG     EQU     0x0800          ; Rec'd Frame longer than 1518 bytes
TOO_SHORT   EQU     0x0400          ; Rec'd Frame shorter than 64 bytes

	END
