/*
 * Some supporting routines for ethernet RDP.
 *
 * Copyright (c) 1994, VLSI Technology Inc. All Rights Reserved.
 *
 * "@(#)eproc.c	1.2	96/06/07 VLSI"
 */

#if !defined(VY86PID)
#error "VY86PID eproc.c included for non-VY86PID build"
#endif /* !VY86PID */

#ifdef SMC91C92
#include "vy86pid/driver.h"
#include "global.h"
#include "e9192.h"

unsigned char snap_head[] = { 0xaa, 0xaa, 0x03, 0x00, 0xaa, 0x77, 0x77, 0x77 };

unsigned char daddr[] = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
unsigned char Dest_Addr[] = { 0,0,0,0,0,0 }; /* Rec Packet Dest Address */
unsigned char Src_Addr[] = { 0,0,0,0,0,0 }; /* Rec Packet Source Address */
unsigned char Our_Addr[] = { 00, 0x40, 0x33, 0x28, 0x46, 0xf3 }; /* Our Address */

/*
 * Fills in SNAP header.
 *	length + 0xAAAA + 03 + OUI (3 bytes) + Ethernet type (2 bytes)
 *
 * Where OUI is 0x00aa77 and Ethernet type is 0x7777 for now.
 */
void
enet_header(unsigned char *tbuf, short len)
{
	short l;
	unsigned char *p;

	l = len + 10;
	p = (unsigned char *) &l;
	tbuf[0] = *(p+1);
	tbuf[1] = *p;

	(void) bcopy(snap_head, &tbuf[2], 8);
	return ;
}

unsigned char *
bcopy(unsigned char *sa, unsigned char *da, int len)
{
	unsigned char *p = da;
	for (;len > 0; *da++=*sa++, len--);
	return (p);
}
#endif
