        TTL     C-Demon global memory and variable definitions    > globals_h.s
        ; ---------------------------------------------------------------------
        ; $Revision: 0.1 $
        ;   $Author: jsmith $
        ;     $Date: 941030 $
        ;
        ; Original author: Geary Chopoff.
        ;
        ; Copyright (c) 1994, VLSI Technology Inc. All Rights Reserved.
        ; ---------------------------------------------------------------------
	; "@(#)global_h.s	1.4	96/06/07 VLSI"
	;
        ; For those architectures supported we should set the boolean
        ; to NULL if the variable has not been pre-defined. This
        ; leaves the job of defining one of the variables to TRUE as
        ; part of the make sequence:

        ; VLSI ARM600 based Platform Independant Development board:
        [       (:LNOT: :DEF: VY86PID)
        GBLL    VY86PID
VY86PID SETL    {FALSE}
	GBLL	SMC91C92
SMC91C92	SETL	{FALSE}
        ]

        [       (:LNOT: :DEF: PID3_REV2)
	GBLL	PID3_REV2
PID3_REV2 SETL	{FALSE}
	]

        ; VLSI GSM Kernel development board 2C:
        [       (:LNOT: :DEF: GSM2C)
        GBLL    GSM2C
GSM2C   SETL    {FALSE}
        ]

        ; VLSI ARM650 based development board:
        [       (:LNOT: :DEF: VY86LX650)
            GBLL    VY86LX650
VY86LX650   SETL    {FALSE}
        ]

        ; Communicate Ruby based development board:
        [       (:LNOT: :DEF: RUBY2)
            GBLL    RUBY2
RUBY2       SETL    {FALSE}
        ]

        [       (:LNOT: :DEF: HWBREAKPOINT)
        ; If the hardware breakpoint support has not been explicitly
        ; asked for by the build, then we default to providing soft
        ; breakpoints only.
        GBLL    HWBREAKPOINT
HWBREAKPOINT    SETL    {FALSE}         
        ]

        [       ((:LNOT: RUBY2) :LAND: HWBREAKPOINT)
        ASSERT  (1 = 0) ; HWBREAKPOINT only supported on RUBY2 builds at the moment.
        ]

        ; ---------------------------------------------------------------------

        GBLS    DRIVER
DRIVER  SETS    ""      ; used to find architecture specific files

        [       (VY86PID)
DRIVER  SETS    "vy86pid"
        |
        [       (GSM2C)
DRIVER  SETS    "gsm2c"
        |
        [       (VY86LX650)
DRIVER  SETS    "vy86lx650"
        |
        [       (RUBY2)
DRIVER  SETS    "ruby2"
        |
        ASSERT  (1 = 0) ; Target architecture has not been specified
        ]       ; RUBY2
        ]       ; VY86LX650
        ]       ; GSM2C
        ]       ; VY86PID

        ; Check that we have been given a directory where the target
        ; specific files reside:
        [       (DRIVER = "")
        ASSERT  (1 = 0) ; Target architecture has not been specified
        ]

        !       0,"Building $DRIVER C-Demon"

        ; ---------------------------------------------------------------------

        INCLUDE modes_h.s       ; global ARM processor manifests

        ; ---------------------------------------------------------------------
        ; C-Demon workspace memory layout:

ARMSystemStacks         EQU     0x800
AbortStackBase          EQU     0x900
IRQStackBase            EQU     0xA00
UndefStackBase          EQU     0xB00
UserStackBase           EQU     0xC00
FIQStackBase            EQU     0xD00
SVCStackBase            EQU     0xE00

        ; Unfortunately the current semi-hosted ANSI C library expects
        ; the "CommandLine" to be at the following address:
CommandLine             EQU     0x00F00
                        EXPORT  CommandLine     ; so external code can use it

        ; ---------------------------------------------------------------------

                        ^       CommandLine
                        #       256             ; standard CLI string buffer

        ; ---------------------------------------------------------------------

SWIState_Active         EQU 1
SWIState_IgnoreGo       EQU 2

        ; ---------------------------------------------------------------------
        END     ; EOF globals_h.s
