/*> main_prg.c <*/
/*---------------------------------------------------------------------------*/
/* Main RDI/RDP processing control loop. The file is also a holder for
 * some target independant support routines.
 *
 * $Revision: 0.1 $
 *   $Author: jsmith $
 *     $Date: 941030 $
 *
 * Copyright (C) 1994 VLSI Technology Inc. All rights reserved.
 *
 * "@(#)main_prg.c	1.4	96/06/07 VLSI"
 */
/*---------------------------------------------------------------------------*/

#include "global.h"
#include "rdi.h"

#ifdef SMC91C92
int send_flag = 0;
#endif

/*---------------------------------------------------------------------------*/
/* Level1RDI is the main RDI processing routine. It should be called
 * with the ID number for the RDP message to be processed.
 */
extern void Level1RDI(int num) ;

extern void ROMReset(void) ; /* used to re-start the C-Demon world */

/*---------------------------------------------------------------------------*/
/* This is the main RDP processing control loop. It is very simple,
 * passing the actual interpretation of the protocol bytes to the
 * Level1RDI routine.
 */
void main_prg(void)
{
 unsigned char c ;

 while (1 == 1) /* Stay in this loop until an RDP_Reset occurs */
  {
   c = GetByte() ;  /* get byte from serial port */
   if (c == RDP_Reset) /* is it the RDI reset? */
    ROMReset() ;         /* if so then REBOOT */

   (void)Level1RDI(c) ;        /* otherwise have RDI decipher it */
  }
 /* This point is never reached */
 return ;
}

/*---------------------------------------------------------------------------*/
/*-- General support routines -----------------------------------------------*/
/*---------------------------------------------------------------------------*/

unsigned int GetWord(void)
{
 unsigned int result ;
 result  = (GetByte() <<  0) ;
 result |= (GetByte() <<  8) ;
 result |= (GetByte() << 16) ;
 result |= (GetByte() << 24) ;
 return(result) ;
}

/*---------------------------------------------------------------------------*/

void PutWord(unsigned int word)
{
#ifdef SMC91C92
	send_flag = 1;

	if (use_enet) {
		volatile unsigned char *xbuf;
		xbuf = (vuptr) TXADDR;

		enet_header((unsigned char *) xbuf, 4);
		*(xbuf+10) = (unsigned char)((word >>  0) & 0xFF);
		*(xbuf+11) = (unsigned char)((word >>  8) & 0xFF);
		*(xbuf+12) = (unsigned char)((word >>  16) & 0xFF);
		*(xbuf+13) = (unsigned char)((word >>  24) & 0xFF);
		ENET_TX((unsigned char *) xbuf, 14, &daddr[0]);
	}

	if (use_serial) {
		PutByte((unsigned char)((word >>  0) & 0xFF)) ;
		PutByte((unsigned char)((word >>  8) & 0xFF)) ;
		PutByte((unsigned char)((word >> 16) & 0xFF)) ;
		PutByte((unsigned char)((word >> 24) & 0xFF)) ;
	}

	send_flag = 0;
#else
	PutByte((unsigned char)((word >>  0) & 0xFF)) ;
	PutByte((unsigned char)((word >>  8) & 0xFF)) ;
	PutByte((unsigned char)((word >> 16) & 0xFF)) ;
	PutByte((unsigned char)((word >> 24) & 0xFF)) ;
#endif
	return ;
}

/*---------------------------------------------------------------------------*/
/* PrintString : Output a NUL terminated ASCII string */

void PrintString(char *cp)
{
#ifdef SMC91C92
	send_flag = 1;

	if (use_enet) {
		unsigned char *p = (unsigned char *) cp;
		short l = 0;

		while (p && (*p++ != '\0'))
			l++;
		if (l) {
			volatile unsigned char *xbuf;
			xbuf = (vuptr) TXADDR;
			enet_header((unsigned char *) xbuf, l);
			(void) bcopy((unsigned char *) cp, (unsigned char *) (xbuf+10), (int) l);
			ENET_TX((unsigned char *) xbuf, l+10, &daddr[0]);
		}
	}

	if (use_serial) {
		while (cp && (*cp != '\0'))
			PutByte((unsigned char)(*cp++)) ;
	}

	send_flag = 0;
#else
	while (cp && (*cp != '\0'))
		PutByte((unsigned char)(*cp++)) ;

	/* NOTE: We may need to provide special code for certain big-endian data */
#endif
	return ;
}

/*---------------------------------------------------------------------------*/

void SetTimer(unsigned int tick)
{
 TickVal = tick ;
 return ;
}

/*---------------------------------------------------------------------------*/

unsigned int ReadTimer(void)
{
 return(TickVal) ;
}

/*---------------------------------------------------------------------------*/
/*> EOF main_prg.c <*/
