/*> mmu.h <*/
/* This file provides the definitions for the standard ARM6x0 MMU.
 *
 * $Revision: 0.1 $
 *   $Author: jsmith $
 *     $Date: 941103 $
 *
 * Copyright (c) 1994, VLSI Technology Inc. All Rights Reserved.
 */
/*---------------------------------------------------------------------------*/

#ifndef __cdemon_mmu_h
#define __cdemon_mmu_h

/*---------------------------------------------------------------------------*/
/* External Routines (in "mmusupp.s") */
extern void putMMU(int copreg,int copvalue) ;
extern int  getMMU(int copreg) ;

/************************************************\
*               MMU constants                    *
\************************************************/

#define MMUCP               15
#define MMUIDReg            0
#define MMUControlReg       1
#define MMUPageTableBaseReg 2
#define MMUDomainAccessReg  3
#define MMUFlushTLBReg      5
#define MMUPurgeTLBReg      6
#define MMUFlushIDCReg      7
#define PageTable1Size      4 * 4 * 1024    /* one per megabyte */

#define MMU                 0x01            /* 0 is off, 1 is on */
#define AlignFault          0x02            /* 0 is off, 1 is on */
#define Cache               0x04            /* 0 is off, 1 is on */
#define WriteBuffer         0x08            /* 0 is off, 1 is on */
#define Prog32              0x10            /* 0 = OFF = program allowed 26 bit addr space, else 32 bit addr space */
#define Data32              0x20            /* 0 = OFF = data allowed 26 bit addr space, else 32 bit addr space */
#define LateAbort           0x40            /* 0 = OFF = Early abort mode, else late abort mode */
#define BigEndian           0x80            /* 0 = OFF = little endia, else Big Endian */

#define Config32Bit         Prog32 + Data32     /* mmu, idc, wb off, 32 bit prog/data, little endian */

#define EnableMMU32         Config32Bit + MMU + Cache + WriteBuffer /* and NO AlignFault */

/*---------------------------------------------------------------------------*/

#endif /* __cdemon_mmu_h */

/*---------------------------------------------------------------------------*/
/*> EOF mmu.h <*/
