        TTL     ARM6x0 MMU support routines                         > mmusupp.s
        ; ---------------------------------------------------------------------
        ; This file provides some lo-level assembler support routines
        ; for working with the ARM6x0 Memory Management Unit.
        ;
        ; $Revision: 0.1 $
        ;   $Author: jsmith $
        ;     $Date: 941102 $
        ;
        ; Copyright (c) 1994, VLSI Technology Inc. All Rights Reserved.
        ; ---------------------------------------------------------------------

        INCLUDE global_h.s          ; for MMU constants
        INCLUDE $DRIVER./driver_h.s ; for target specific MMU constants

        ; ---------------------------------------------------------------------

        EXPORT  getMMU
        EXPORT  putMMU

        AREA    |C-Demon$$MMUSupport|,CODE,READONLY

        ; ---------------------------------------------------------------------
        ; unsigned int getMMU(int mmucoprocreg) ;
        ; Return the value for the specified MMU co-processor register.
getMMU
        CMP     a1,#0
        MRCEQ   MMUCP,0,a1,c0,c0        ; c0 = coprocessor register 0
        CMP     a1,#1
        MRCEQ   MMUCP,0,a1,c1,c0
        CMP     a1,#2
        MRCEQ   MMUCP,0,a1,c2,c0
        CMP     a1,#3
        MRCEQ   MMUCP,0,a1,c3,c0
        CMP     a1,#4
        MRCEQ   MMUCP,0,a1,c4,c0
        CMP     a1,#5
        MRCEQ   MMUCP,0,a1,c5,c0
        CMP     a1,#6
        MRCEQ   MMUCP,0,a1,c6,c0
        CMP     a1,#7
        MRCEQ   MMUCP,0,a1,c7,c0
        MOV     pc,lr

        ; ---------------------------------------------------------------------
        ; void putMMU(int mmucoproreg,unsigned int value) ;
        ; Write the given value to the specified MMU co-processor register.
putMMU
        CMP     a1,#0
        MCREQ   MMUCP,0,a2,c0,c0        ; c0 = coprocessor register 0
        CMP     a1,#1
        MCREQ   MMUCP,0,a2,c1,c0
        CMP     a1,#2
        MCREQ   MMUCP,0,a2,c2,c0
        CMP     a1,#3
        MCREQ   MMUCP,0,a2,c3,c0
        CMP     a1,#4
        MCREQ   MMUCP,0,a2,c4,c0
        CMP     a1,#5
        MCREQ   MMUCP,0,a2,c5,c0
        CMP     a1,#6
        MCREQ   MMUCP,0,a2,c6,c0
        CMP     a1,#7
        MCREQ   MMUCP,0,a2,c7,c0
        MOV     pc,lr

        ; ---------------------------------------------------------------------
        END     ; EOF mmusupp.s
