        TTL     Standard ARM processor manifests                    > modes_h.s
	; "@(#)modes_h.s	1.2	96/06/07 VLSI"
        ; ---------------------------------------------------------------------
        ; $Revision: 0.1 $
        ;   $Author: jsmith $
        ;     $Date: 941103 $
        ;
        ; Copyright (c) 1994, VLSI Technology Inc. All Rights Reserved.
        ; ---------------------------------------------------------------------
        ; NOTE: The ARM processor does not allow code executing in USR
        ; mode to change the processor mode or update the IRQ and FIQ
        ; disable flags. This means that an ARM exception must be
        ; taken to get into a priviledged mode (i.e. a non-USR mode)
        ; before the CPSR can be updated. Normally this is achieved
        ; via a SWI instruction (e.g. SWI EnterOS), though undefined
        ; instructions, aborts and even interrupts can be used.
        ; ---------------------------------------------------------------------

IRQint          EQU     0x80                ; disables IRQ interrupts when set in CPSR
FIQint          EQU     0x40                ; disables FIQ interrupts when set in CPSR
NoInt           EQU     (FIQint | IRQint)   ; disable both FIQ and IRQ

        ; We only provide support for the 32bit modes:
USRmode         EQU     0x10        ; USR32
FIQmode         EQU     0x11        ; FIQ32
IRQmode         EQU     0x12        ; IRQ32
SVCmode         EQU     0x13        ; SVC32
ABORTmode       EQU     0x17        ; ABT32
UNDEFmode       EQU     0x1B        ; UND32

PSR_32Bit       EQU     0x10        ; check for 26- or 32-bit processor modes
ModeMask        EQU     0x1F        ; mask for PSR mode bits
SubModeMask     EQU     0x0F
CCMask          EQU     0xF0000000  ; PSR arithmetic condition codes

        ; ---------------------------------------------------------------------
        END     ; EOF modes_h.s
