        TTL     C-Demon RDI/RDP manifests                             > rdi_h.s
	; "@(#)rdi_h.s	1.2	96/06/07 VLSI"
        ; ---------------------------------------------------------------------
        ; The following manifests must be manually kept in step with
        ; the C-Demon source and the duplicate definitions in the
        ; "rdi.h" header file.
        ;
        ; $Revision: 0.1 $
        ;   $Author: jsmith $
        ;     $Date: 941103 $
        ;
        ; Copyright (c) 1994, VLSI Technology Inc. All Rights Reserved.
        ; ---------------------------------------------------------------------
        ; Error return codes:

RDIError_NoError                EQU     0       ; Good return

RDIError_Reset                  EQU     1
RDIError_UndefinedInstruction   EQU     2
RDIError_SoftwareInterrupt      EQU     3
RDIError_PrefetchAbort          EQU     4
RDIError_DataAbort              EQU     5
RDIError_AddressException       EQU     6
RDIError_IRQ                    EQU     7
RDIError_FIQ                    EQU     8
RDIError_Error                  EQU     9
RDIError_BranchThrough0         EQU     10

RDIError_NotInitialised         EQU     128
RDIError_UnableToInitialise     EQU     129
RDIError_WrongByteSex           EQU     130
RDIError_UnableToTerminate      EQU     131
RDIError_BadInstruction         EQU     132
RDIError_IllegalInstruction     EQU     133
RDIError_BadCPUStateSetting     EQU     134
RDIError_UnknownCoPro           EQU     135
RDIError_UnknownCoProState      EQU     136
RDIError_BadCoProState          EQU     137
RDIError_BadPointType           EQU     138
RDIError_UnimplementedType      EQU     139
RDIError_BadPointSize           EQU     140
RDIError_UnimplementedSize      EQU     141
RDIError_NoMorePoints           EQU     142
RDIError_BreakpointReached      EQU     143
RDIError_WatchpointAccessed     EQU     144
RDIError_NoSuchPoint            EQU     145
RDIError_ProgramFinishedInStep  EQU     146
RDIError_UserInterrupt          EQU     147
RDIError_NoPCValue              EQU     148

RDIError_LittleEndian           EQU     240
RDIError_BigEndian              EQU     241

RDIError_InsufficientPrivilege  EQU     253
RDIError_UnimplementedMessage   EQU     254
RDIError_UndefinedMessage       EQU     255

        ; ---------------------------------------------------------------------
        ; RDPMessage Values:

RDP_Open                EQU     0x00
RDP_Close               EQU     0x01
RDP_Read                EQU     0x02
RDP_Write               EQU     0x03
RDP_CPURead             EQU     0x04
RDP_CPUWrite            EQU     0x05
RDP_CPRead              EQU     0x06
RDP_CPWrite             EQU     0x07
RDP_SetBreak            EQU     0x0A
RDP_ClearBreak          EQU     0x0B
RDP_SetWatch            EQU     0x0C
RDP_ClearWatch          EQU     0x0D

RDP_Execute             EQU     0x10
RDP_ExecSync            EQU     0       ;sync  = send ACK when done
RDP_ExecAsync           EQU     1       ;async = immediate ACK

RDP_Step                EQU     0x11
RDP_Info                EQU     0x12

RDP_OSOpReply           EQU     0x13
RDP_LastRequest         EQU     0x13

RDP_Stopped             EQU     0x20
RDP_OSOp                EQU     0x21
RDP_Fatal               EQU     0x5E
RDP_Return              EQU     0x5F
RDP_Reset               EQU     0x7F

        ; ---------------------------------------------------------------------
        ; Miscellaneous RDI Values:

RDISex_Little           EQU     0       ;the byte sex of the debuggee
RDISex_Big              EQU     1
RDISex_DontCare         EQU     2

RDIPoint_EQ             EQU     0       ;the different types of break/watchpoints
RDIPoint_GT             EQU     1
RDIPoint_GE             EQU     2
RDIPoint_LT             EQU     3
RDIPoint_LE             EQU     4
RDIPoint_IN             EQU     5
RDIPoint_OUT            EQU     6

RDIWatch_ByteRead       EQU     1       ;types of data accesses to watch for
RDIWatch_HalfRead       EQU     2
RDIWatch_WordRead       EQU     4
RDIWatch_ByteWrite      EQU     8
RDIWatch_HalfWrite      EQU     16
RDIWatch_WordWrite      EQU     32

RDIReg_R15              EQU     (1 << 15)       ;mask values for CPU
RDIReg_PC               EQU     (1 << 16)
RDIReg_CPSR             EQU     (1 << 17)
RDIReg_SPSR             EQU     (1 << 18)
RDINum_CPURegs          EQU     19

RDINum_CPRegs           EQU     10      ;current maximum

RDIMode_Curr            EQU     255

RDIInfo_Target          EQU     0
RDIInfo_Points          EQU     1
RDIInfo_Step            EQU     2
RDIInfo_MMU             EQU     3

RDISignal_Stop          EQU     0x100

RDIVector_Catch         EQU     0x180

RDIInfo_Cycles          EQU     0x200
RDIInfo_CyclesSize      EQU     48

RDIInfo_ErrorP          EQU     0x201

RDISet_Cmdline          EQU     0x300

RDPOpen_Start           EQU     1
RDPOpen_ResetLine       EQU     2
RDPOpen_SexBig          EQU     4
RDPOpen_SexDontCare     EQU     8

        ; ---------------------------------------------------------------------
        END     ; EOF rdi_h.s
