/*> swi.h
 *
 * $Revision: 0.1 $
 *   $Author: jsmith $
 *     $Date: 941030 $
 *
 * Copyright (c) 1994, VLSI Technology Inc. All Rights Reserved.
 *
 * "@(#)swi.h	1.2	96/06/07 VLSI"
 */
/*---------------------------------------------------------------------------*/

#ifndef __cdemon_swi_h
#define __cdemon_swi_h

/*---------------------------------------------------------------------------*/
/* The following prototypes declare pseudo-functions to the C
 * compiler, that map directly onto SWI instructions. The C-Demon
 * build world should *NOT* use these versions, since the code can
 * directly call the internal functions. However this allows
 * application programs based above C-Demon to use in-line SWI calls:
 */

void                     __swi(0x00) SWI_WriteC(int ch) ;       /* write char in ch to console */
void                     __swi(0x02) SWI_Write0(char *cp) ;     /* write NUL terminated string to console */
unsigned int             __swi(0x04) SWI_ReadC(void) ;          /* read character from the console */
void                     __swi(0x05) SWI_CLI(const char *cp) ;  /* Pass NUL terminated string to host debuggers Command Line Interpreter (CLI) */
__value_in_regs ret2parm __swi(0x10) SWI_GetEnv(void) ;         /* Read command line address and highest available RAM address */
void                     __swi(0x11) SWI_Exit(void) ;           /* done with program (or process) */
void                     __swi(0x13) SWI_EnableINT(void) ;      /* enable both IRQ and FIQ interrupts */
void                     __swi(0x14) SWI_DisableINT(void) ;     /* disable both IRQ and FIQ interrupts */
void                     __swi(0x16) SWI_EnterOS(void) ;        /* enter SVC (supervisor) mode */
unsigned int             __swi(0x60) SWI_GetErrno(void) ;       /* get value of "errno" */
unsigned int             __swi(0x61) SWI_Clock(void) ;          /* read the system clock */
unsigned int             __swi(0x63) SWI_Time(void) ;           /* get number of seconds since 1st January 1970 (Un*x time) */
unsigned int             __swi(0x64) SWI_Remove(char *cp) ;     /* remove (delete) NUL terminated filename */
unsigned int             __swi(0x65) SWI_Rename(char *oldfn,char *newfn) ; /* rename oldfn to newfn (NUL terminated filenames) */
unsigned int             __swi(0x66) SWI_Open(char *fn,int mode) ; /* open NUL terminated filename with given mode */
unsigned int             __swi(0x67) SWI_GetVector(int vecnum); /* get pointer to handler attached to vector */
unsigned int             __swi(0x68) SWI_Close(unsigned int handle) ; /* close file described by the given handle */
unsigned int             __swi(0x69) SWI_Write(unsigned int handle,char *buf,int numbytes) ; /* write bytes to file described by handle */
unsigned int             __swi(0x6A) SWI_Read(unsigned int handle,char *buf,int numbytes) ; /* read bytes from file described by handle */
unsigned int             __swi(0x6B) SWI_Seek(unsigned int handle,unsigned int pos) ; /* move pointer to specified file position */
long int                 __swi(0x6C) SWI_Flen(unsigned int handle) ; /* get length of file described by handle, or -1 if not possible */
int                      __swi(0x6E) SWI_IsTTY(unsigned int handle) ; /* returns 1 if file is TTY, else 0 */
unsigned int             __swi(0x6F) SWI_TmpNam(char *buf,int buflen) ; /* generates a temporary filename */
__value_in_regs ret3parm __swi(0x70) SWI_InstallHandler(int vecnum,int privarg,void (*vecp)()); /* install a handler onto a C-Demon vector */
void                     __swi(0x71) SWI_GenerateError(void *errblk,void *regblk) ; /* create error using given errblk and regblk */

/*---------------------------------------------------------------------------*/

#define SWIEnterOS (0x16) /* see above for description */

/*---------------------------------------------------------------------------*/

#endif /* __cdemon_swi_h */

/*---------------------------------------------------------------------------*/
/*> EOF swi.h <*/
